--[[ SimpleTip (redux) by Ayradyss
	Based on Skeeve of Proudmore's SimpleTip 1.2.4 and updated for new patches.
	Original mod can be found at http://www.curse-gaming.com/mod.php?addid=425 
	All credit for actual code should go to Skeeve.  ]]--


SimpleTipParms = {move=false, x=0, y=0, anchor="CENTER", PvP=true, PvPrank = true, Color = "pvp"}
---------------------------------------------------
-- main tooltip adjuster function
function SimpleTip_TweakTip(unit, flagRSP)
	local numlines = GameTooltip:NumLines();
	local tmp = nil;
	local tmp2,tmp3;
	local idx = nil;
	local level = nil;
	if flagRSP == nil then flagRSP = false end;
	

	--Configurable PvP line show/hide
	if (SimpleTipParms.PvP == false) then
		tmp = getglobal("GameTooltipTextLeft"..numlines);
		if (tmp) then
			if ((tmp:GetText()==PVP_ENABLED) or (tmp:GetText()==PVP_DISABLED)) then
				tmp:SetText(nil);
			end
		end
	end
	
	-- Player tooltip text
	if not flagRSP then
		if (UnitIsPlayer(unit)) then
		--Show/hide PvP rank
			if (SimpleTipParms.PvPrank == false) then
				if UnitName(unit) then GameTooltipTextLeft1:SetText(UnitName(unit), 1.0, 1.0, 1.0) end
			else
				if UnitPVPName(unit) then GameTooltipTextLeft1:SetText(UnitPVPName(unit), 1.0, 1.0, 1.0) end;	
			end
			level = UnitLevel(unit);
			if(level < 0) then level = "??" end;
			GameTooltipTextLeft2:SetText(UnitRace(unit).." "..UnitClass(unit)..", "..LEVEL.." "..level, 1.0, 1.0, 1.0);
			tmp = GetGuildInfo(unit);
			if (tmp) then
				local tmp2 = GameTooltipTextLeft3:GetText();
				if(tmp2) then
					GameTooltipTextLeft3:SetText("<"..tmp..">","", 1.0, 1.0, 1.0); --Always line 3
					GameTooltip:AddLine("(blank)"); --Now one more line
					for x = 4, GameTooltip:NumLines() do
						tmp3 = getglobal("GameTooltipTextLeft"..x):GetText();
						if ((tmp3 ~= nil) and string.find(tmp3, tmp)) then 
							GameTooltipTextLeft3:SetText(tmp3)
							tmp3 = nil;
						end --double guild line?  Use the other one.
						getglobal("GameTooltipTextLeft"..x):SetText(tmp2);
						tmp2 = tmp3;
					end
				else
					GameTooltip:AddLine("<"..tmp..">","", 1.0, 1.0, 1.0);
				end
			end
		end
	end
	
	-- tooltip colors
	if (UnitExists(unit)) then
		if (SimpleTipParms.Color ~= "off") then
			local r, g, b = GameTooltip_UnitColor(unit);
			-- if they're *all* 1.0, then they're a friendly player; make it blue
			if (r*b*g == 1.0) then
				r=0.0; b=1.0; g=0.0;
			end
			if (SimpleTipParms.Color == "raid") then
				local _, class = UnitClass(unit);
				if UnitIsPlayer(unit) and UnitIsFriend("player", unit) and RAID_CLASS_COLORS[class] ~= nil then
--					GameTooltip:SetBackdropColor(RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b);
					r = RAID_CLASS_COLORS[class].r;
					g = RAID_CLASS_COLORS[class].g;
					b = RAID_CLASS_COLORS[class].b;
				end
			end
			if ((r ~= TOOLTIP_DEFAULT_BACKGROUND_COLOR.r) or
				(g ~= TOOLTIP_DEFAULT_BACKGROUND_COLOR.g) or
				(b ~= TOOLTIP_DEFAULT_BACKGROUND_COLOR.b)) then
				GameTooltip:SetBackdropColor(r, g, b);
			end
		end
		GameTooltipTextLeft1:SetTextColor(1.0, 0.82, 0.0);
	end
	GameTooltip:Show();
end

function SimpleTip_xTooltip_Update()
	SimpleTip_Old_xTooltip_Update();
	SimpleTip_TweakTip("mouseover", true);
end

---------------------------------------------------
-- GameTooltip OnEvent() hook
function SimpleTip_OnEvent(event)
	if (event == "UPDATE_MOUSEOVER_UNIT") then
		if(UnitIsConnected("mouseover") or UnitIsPlayer("mouseover")) then 
			SimpleTip_TweakTip("mouseover", false);
		end
	elseif (event == "ADDON_LOADED") and (string.lower(arg1) == "flagrsp") then
		SimpleTip_Old_xTooltip_Update = xTooltip_Update;
		xTooltip_Update = SimpleTip_xTooltip_Update;
	end
end
	
---------------------------------------------------
-- UnitFrame OnEnter() hook
function SimpleTip_UnitFrame_OnEnter(self)
	--SimpleTip_Old_UnitFrame_OnEnter(self);
	if (SHOW_NEWBIE_TIPS ~= "1") then
		SimpleTip_TweakTip(this.unit, false);
	end
end

---------------------------------------------------
-- GameTooltip SetDefaultAnchor() hook
function SimpleTip_GameTooltip_SetDefaultAnchor(tooltip, parent)
	if (SimpleTipParms.move) then
		if (SimpleTipParms.anchor == string.upper(SimpleTip_Pointer_Txt)) then
			tooltip:SetOwner(parent, "ANCHOR_CURSOR");
		else
			tooltip:SetOwner(parent, "ANCHOR_NONE");
			tooltip:SetPoint(SimpleTipParms.anchor, "UIParent", SimpleTipParms.anchor, SimpleTipParms.x, SimpleTipParms.y);
		end
	end
end

---------------------------------------------------
-- dump message into chat window
function SimpleTip_ChatMsg(msg)
	if (msg) then
		-- tags
		local white = "<white>";
		local grey = "<grey>";
		local yellow = "<yellow>";
		-- syntax highlighting for help
		msg = string.gsub(msg, "/", white.."/");
		msg = string.gsub(msg, "{", yellow.."{"..grey);
		msg = string.gsub(msg, "}", yellow.."}"..grey);
		msg = string.gsub(msg, "|", yellow.."||"..grey);
		-- go to yellow at the start by default
		msg = yellow .. msg;
		-- switch out color tags for actual codes
		msg = string.gsub(msg, white, "|cffffffff");
		msg = string.gsub(msg, grey, "|ccccccccc");
		msg = string.gsub(msg, yellow, "|cffffd100");
		-- add message to chat frame
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end

---------------------------------------------------
-- check an array for a given value
function contains(t, item)
	for key, value	in pairs(t) do
		if (item == value) then
			return true;
		end
	end
	return false;
end

---------------------------------------------------
-- handler for /simpletip commands
function SimpleTip_SlashHandler(msg)
	local OffsetX = {TOPLEFT=10, TOP=0, TOPRIGHT=-10,
			LEFT=10, CENTER=0, RIGHT=-10,
			BOTTOMLEFT=10, BOTTOM=0, BOTTOMRIGHT=10};
	local OffsetY = {TOPLEFT=-10, TOP=-10, TOPRIGHT=-10,
			LEFT=0, CENTER=0, RIGHT=0,
			BOTTOMLEFT=20, BOTTOM=20, BOTTOMRIGHT=20};
	local argv = {};
	for arg in string.gmatch(string.lower(msg), '[%a%d%-%.]+') do
		table.insert(argv, arg);
	end

	-- if an anchor point is given as the command, we'll accept that :)
	if (contains(SimpleTip_Pos_Anchor, argv[1])) then
		argv[2] = argv[1];
		argv[1] = SimpleTip_Cmd_MoveTo[1];
	end

	if (contains(SimpleTip_Cmd_About, argv[1])) then -- "/simpletip about"
		SimpleTip_ChatMsg(SimpleTip_Credits1_Txt);
		SimpleTip_ChatMsg(SimpleTip_Credits2_Txt);
		SimpleTip_ChatMsg(SimpleTip_Credits3_Txt);
		SimpleTip_ChatMsg(SimpleTip_Credits4_Txt);		
		SimpleTip_ChatMsg(SimpleTip_Credits5_Txt);


	elseif (contains(SimpleTip_Cmd_NoMove, argv[1])) then -- "/simpletip nomove"
		SimpleTipParms.move = false;
		SimpleTipParms.anchor = "CENTER";
		SimpleTipParms.x = 0;
		SimpleTipParms.y = 0;
		SimpleTip_ChatMsg(SimpleTip_NoMove_Txt);

	elseif (contains(SimpleTip_Cmd_MoveTo, argv[1])) then -- "/simpletip moveto ..."
		-- relocate tooltip to anchor points
		if (contains(SimpleTip_Pos_Anchor, argv[2])) then
			SimpleTipParms.move = true;
			SimpleTipParms.anchor = string.upper(argv[2]);
			SimpleTipParms.x = OffsetX[SimpleTipParms.anchor];
			SimpleTipParms.y = OffsetY[SimpleTipParms.anchor];
			SimpleTip_ChatMsg(string.format(SimpleTip_MoveTo_Txt, string.lower(SimpleTipParms.anchor)));
			SimpleTip_ChatMsg(string.format(SimpleTip_Offset_Txt, SimpleTipParms.x, SimpleTipParms.y));
		-- relocate tooltip to mouse
		elseif (contains(SimpleTip_Pos_Pointer, argv[2])) then
			SimpleTipParms.move = true;
			SimpleTipParms.anchor = string.upper(SimpleTip_Pointer_Txt);
			SimpleTipParms.x = 0;
			SimpleTipParms.y = 0;
			SimpleTip_ChatMsg(string.format(SimpleTip_MoveTo_Txt, string.lower(SimpleTipParms.anchor)));
		-- display movement help
		else
			SimpleTip_ChatMsg(SimpleTip_MoveToHelp_Txt);
			SimpleTip_ChatMsg(SimpleTip_NoMoveHelp_Txt);
		end

	elseif (contains(SimpleTip_Cmd_Offset, argv[1])) then -- "/simpletip offset"
		if (SimpleTipParms.anchor ~= SimpleTip_Pos_Mouse) then
			-- set tooltip x,y offset
			local x=tonumber(argv[2]);
			local y=tonumber(argv[3]);
			if (x and y) then
				SimpleTipParms.x = x;
				SimpleTipParms.y = y;
				SimpleTip_ChatMsg(string.format(SimpleTip_Offset_Txt, SimpleTipParms.x, SimpleTipParms.y));
			else -- display offset help
				SimpleTip_ChatMsg(SimpleTip_OffsetHelp_Txt);
				SimpleTip_ChatMsg(SimpleTip_OffsetHelp2_Txt);
			end
		else -- display mouseoffset message
			SimpleTip_ChatMsg(SimpleTip_PointerOffset_Txt);
		end

	elseif (contains(SimpleTip_Cmd_Status, argv[1])) then -- "/simpletip status"
		if (SimpleTipParms.move) then
			SimpleTip_ChatMsg(string.format(SimpleTip_MoveTo_Txt, string.lower(SimpleTipParms.anchor)));
			SimpleTip_ChatMsg(string.format(SimpleTip_Offset_Txt, SimpleTipParms.x, SimpleTipParms.y));
		else
			SimpleTip_ChatMsg(SimpleTip_NoMove_Txt);
		end

	elseif (contains(SimpleTip_Cmd_Help, argv[1])) then -- "/simpletip help"
		SimpleTip_ChatMsg(SimpleTip_Help_Txt);
		SimpleTip_ChatMsg(SimpleTip_MoveToHelp_Txt);
		SimpleTip_ChatMsg(SimpleTip_NoMoveHelp_Txt);
		SimpleTip_ChatMsg(SimpleTip_OffsetHelp_Txt);
		SimpleTip_ChatMsg(SimpleTip_OffsetHelp2_Txt);

	elseif(contains(SimpleTip_Cmd_PvP, argv[1])) then
		if(argv[2]) then
			if (argv[2] == "show") then 
				SimpleTipParms.PvP = true;
			elseif (argv[2] == "hide") then
				SimpleTipParms.PvP = false;
			else
				SimpleTip_ChatMsg(SimpleTip_PvP_Help);
			end
		end
		if(SimpleTipParms.PvP) then 
			SimpleTip_ChatMsg(string.format(SimpleTip_PvP_Status, "Showing"));
		else
			SimpleTip_ChatMsg(string.format(SimpleTip_PvP_Status, "Hiding"));
		end
	elseif(contains(SimpleTip_Cmd_PvPrank, argv[1])) then
		if(argv[2]) then
			if (argv[2] == "show") then 
				SimpleTipParms.PvPrank = true;
			elseif (argv[2] == "hide") then
				SimpleTipParms.PvPrank = false;
			else
				SimpleTip_ChatMsg(SimpleTip_PvPrank_Help);
			end
		end
		if(SimpleTipParms.PvPrank) then 
			SimpleTip_ChatMsg(string.format(SimpleTip_PvPrank_Status, "Showing"));
		else
			SimpleTip_ChatMsg(string.format(SimpleTip_PvPrank_Status, "Hiding"));
		end
	elseif(contains(SimpleTip_Cmd_Colors, argv[1])) then
		if(argv[2]) then
			if (argv[2] == "raid") then 
				SimpleTipParms.Color = "raid";
			elseif (argv[2] == "pvp") then
				SimpleTipParms.Color = "pvp";
			elseif (argv[2] == "off") then
				SimpleTipParms.Color = "off";
			else
				SimpleTip_ChatMsg(SimpleTip_Color_Help);
			end
		end
		if(SimpleTipParms.Color == "raid") then 
			SimpleTip_ChatMsg(string.format(SimpleTip_Color_Status, "raid class color"));
		elseif(SimpleTipParms.Color == "pvp") then 
			SimpleTip_ChatMsg(string.format(SimpleTip_Color_Status, "PvP status or hostility"));
		else
			SimpleTip_ChatMsg(string.format(SimpleTip_Color_Status, "default"));
		end
						
	else -- "/simpletip help" (or anything else)
		SimpleTip_ChatMsg(SimpleTip_Help_Txt);
	end
end

---------------------------------------------------
-- init stuff
function SimpleTip_OnLoad()
	hooksecurefunc("UnitFrame_OnEnter", SimpleTip_UnitFrame_OnEnter);
	hooksecurefunc("GameTooltip_SetDefaultAnchor", SimpleTip_GameTooltip_SetDefaultAnchor);

	SlashCmdList["SIMPLETIPCOMMAND"] = SimpleTip_SlashHandler;
	SLASH_SIMPLETIPCOMMAND1 = "/simpletip";
	SLASH_SIMPLETIPCOMMAND2 = "/stip";
	
	this:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
	this:RegisterEvent("ADDON_LOADED");
	
	if(xTooltip_Update) then
		SimpleTip_Old_xTooltip_Update = xTooltip_Update;
		xTooltip_Update = SimpleTip_xTooltip_Update;
	end

	SimpleTip_ChatMsg(SimpleTip_Load_Txt);
	if(SimpleTipParms.PvP == nil) then SimpleTipParms.PvP = true end;
end
